///////////////////////////////////////////////////
//DoppelPendel Phasendiagramm für w2 = 0 (Pointcare)
/////////////////////////////////////////////////////

//Mit diesen Parametern Ordnung!
float lP = 250;//Pendellänge in Pixel
float wAlt = 3*PI/4;//Winkel zu Beginn
float gAlt = -2.95;//Winkelgeschwindigkeit zu Beginn. 
float dt = 0.01;//Zeitintervall
float wNeu, gNeu;//Neuer Winkel, neue Winkelgeschwindigkeit
float K = 1.50; //bestimmt die Stärke der periodischen Kraft nach unten
//Da man sich bei diesem Bereich von K im Chaos aufhält, wird das Phasenbild jedesmal anders aussehen
float wK, gK;//Für Phasendiagramm
int t = 0;
color farbe = color(255);
float T = 13; //Zeit zwischen zwei Impulsen
int j = 0;


void setup() {
  size(600, 1200); 
  ellipseMode(CENTER);
  frameRate(150);
  background(0);
  println("K = "+K);
}

void draw(){
  if(wAlt >  PI) wAlt = -2*PI+wAlt;
  if(wAlt < -PI) wAlt =  2*PI+wAlt;
  fill(255);
  noStroke();
  rect(0,0,600,600);//Pendelbild löschen
  
  if(frameCount  % T == 0 ){
      println(frameCount);
      wNeu = wF(wAlt, gAlt);
      gNeu = gF(wAlt, gAlt);
      //println("oben "+wAlt,wNeu,gAlt,gNeu);
      fill(200,0,0);
      ellipse(300,300,25,25);
      stroke(30);
      strokeWeight(8);
      line(300,300,300 + lP*cos(PI/2-wNeu), 300 + lP*sin(PI/2-wNeu));
      strokeWeight(2);
      fill(0,0,100);
      ellipse(300 + lP*cos(PI/2-wNeu), 300 + lP*sin(PI/2-wNeu),54,54);
      //Immer, wenn Kraftstoß erfolgt, Phasenpunkt eintragen (Poincare-Schnitt)
      wK = map(wNeu,-PI,PI,10,590);    //Winkel auf Bilde-x-Koordinaten mappen
      gK = map(gNeu,-10-abs(gAlt)/2, 10+abs(gAlt)/2,600,1200); //Winkelgeschw. auf Bilde-y-Koordinaten mappen
      strokeWeight(4);//Größe der Punkte im Phasendiagramm
      stroke(farbe); 
      point(wK,gK);   
      wAlt = wNeu;
      gAlt = gNeu;
  }
  if(frameCount % T !=0){
      wNeu = wAlt+gAlt*dt; 
      gNeu = gAlt;// Ohne äußere Kraft bleibt die Winkelgeschw. gleich
     // println("unten "+wAlt,wNeu,gAlt,gNeu);
      fill(200,0,0);
      ellipse(300,300,25,25);
      stroke(30);
      strokeWeight(8);
      line(300,300,300 + lP*cos(PI/2-wNeu), 300 + lP*sin(PI/2-wNeu));
      strokeWeight(2);
      fill(0,0,100);
      ellipse(300 + lP*cos(PI/2-wNeu), 300 + lP*sin(PI/2-wNeu),54,54);
      
      wAlt = wNeu;
      gAlt = gNeu;
    
  }
  
}

//Symplectic Euler in w und g
float wF(float w, float g) {
  wNeu =(w + dt*g) ;
  if(abs(wNeu) > PI) wNeu = -wNeu;//-PI/2 < w < PI/2
  return wNeu ;
}

float gF(float w, float g) {
  gNeu = g -K*sin(w+dt*g);
  return gNeu;
}
//Startwinkel und Startwinkelgeschwindigkeit durch Klick ins Phasendiagramm wählen
void mousePressed(){
  noStroke();
  farbe = color(random(100,255),random(100,255),random(100,255));
  stroke(farbe);
  rect(mouseX,mouseY,3,3);//ersten Punkt als Quadrat darstellen
  wAlt = map(mouseX, 0,600,-PI,PI);
  gAlt = map(mouseY,600,1200,-20,20);
}